#!/usr/bin/python3
#!/usr/bin/python3
# -*- coding: utf-8 -*-

import sys
# python3 default code is 'utf-8'
# from importlib import reload
#
# reload(sys)
# sys.
# sys.defaultencoding('utf8')

import os
import dbus
import dbus.service
import traceback
import re
import math
from PyQt5.QtGui import *
from PyQt5.QtCore import *
from PyQt5.QtWidgets import QApplication, QMessageBox, QListWidgetItem

from service.dbus_service import DbusService
from service.kylin_update_service import KylinUpdateService
from utils.enums import LaunchMode, TaskMode, LWMode, AUPSource, AppType, AppMsg, LOADINGWIDTH, LOADINGHEIGHT, \
    MAINWIDTH, MAINHEIGHT, SINTERFACE, SINTERFACES, RUNLIST, DOWN_CACHE_PATH, DOWN_TEMP_PATH, STARTCONF
from utils.common_utils import CommonUtils
from utils.util_dbus import UtilDbus
from utils.log_manager import LogManager
from mainui.updatelistitemwidget import UpdateListItemWidget
from mainui.messagewidget import MessageWidget
from mainui.loadingwidget import LoadingWidget
from mainui.bottomwidget import BottomWidget
from mainui.system_tray import SystemTray
from mainui.menubar import Menubar
from mainui.update_success_widget import *
from mainui.titlebar import *
from mainui.appdetails import *
from utils.db_install_information import  *
from model.upackage import UPackage

import urllib
import urllib.request
import urllib.error
import urllib3
import urllib3.request
import urllib.parse
import socket
import time
import uuid
import threading
import datetime
import locale
import gettext
import fcntl
import platform
from concurrent.futures import ThreadPoolExecutor,wait
from multiprocessing import Pool
from subprocess import check_output
import subprocess
import socket

locale.setlocale(locale.LC_ALL, "")
gettext.bindtextdomain("kylin-update-manager", "/usr/share/locale")
gettext.textdomain("kylin-update-manager")
_ = gettext.gettext

PINGBACK_INTERNET_URL = "http://archive1.kylinos.cn:32294/kylin-update-manager-server/main.php?"
# PINGBACK_INTRANET_URL = "http://archive.kylinos-intranet.cn/kylin-update-manager-server/main.php?"

PKGLIST = []


# 类：用于进行main_work，由于进行外网源配置时时间太长到时线程任然会阻塞界面
class Thread_work(QThread):
    def __init__(self, parent=None):
        QThread.__init__(self)
        self.parent = parent

    def run(self):
        self.parent.main_work()


class Thread_check_update(QThread):
    def __init__(self, parent=None):
        QThread.__init__(self)
        self.parent = parent

    def run(self):
        self.parent.kus.start_access()

class Thread_Download(QThread):
    send_task_signal = pyqtSignal(UpdateListItemWidget)
    def __init__(self, parent=None):
        QThread.__init__(self)
        self.parent = parent
        # self.send_task_signal.connect(self.parent.slot_start_install)

    def run(self):
        while(True):
            if len(self.parent.worklist) == 0:
                time.sleep(0.3)
                continue
            else:
                if self.parent.is_working == False:
                    self.parent.mutex.acquire()
                    self.task = self.parent.worklist.pop(0)
                    self.parent.mutex.release()
            try:
                if hasattr(self.task, "app_msg"):
                    #开始下载
                    self.task.down_deb_pkg()
                    # self.send_task_signal.emit(task)
                else:
                    print("not have attr")
            except:
                print("task is not exitst")


class MainWindow(QWidget):
    service_key = ""
    hash_pwd = ""
    item_map_ordinary = {}
    item_map_important = {}
    item_map = {}
    item_num = 0
    get_app_num = 0
    update_item_map = {}

    has_sp_update = False
    size_ordinary = 0
    size_important = 0
    app_num_ordinary = 0
    app_num_important = 0
    selected_num_ordinary = 0
    selected_num_important = 0

    available_source = AUPSource.NOSOURCE
    is_log_init = False
    is_working = False
    is_working_c = False
    is_working_install = False
    will_install = False
    pkg_download_finish = False
    copy_one_finish = False
    puase = False
    is_error = False
    is_conffile = False
    launch_mode = None
    task_mode = None
    is_SP_update = False
    is_created = False
    is_down_puase = False
    cancel_down_deb = False

    click_config = False
    click_cancel = False

    menu_init = False

    iface = None
    kus = None
    cu = None

    puase_down_list = []
    Wait_install_list = []
    App_Version_list = []
    app_install_statue_list = []
    App_install_num = 0
    install_app_num = 0

    previous_process_type = ""
    worklist = []
    work_list = []
    crucial_worklist = []
    important_worklist = []
    c_work_list = []
    install_fail_list = []
    all_deb_pkg = []
    need_copyfile_list = []
    all_download_size = 0

    get_pos = pyqtSignal()
    signal_show_exit = pyqtSignal(str)
    change_loading_tiplabel = pyqtSignal(str, bool)
    kum_update_finish = pyqtSignal()
    get_down_progress = pyqtSignal(str,str,str,str,str)
    down_deb_finish = pyqtSignal(str)
    installed_deb_finish = pyqtSignal()
    get_install_progress = pyqtSignal(str, float) #lijiang
    start_install_deb = pyqtSignal(str) #lijiang
    submit_download_task = pyqtSignal() #lijiang
    send_pause_signal = pyqtSignal() #网络异常后通知所有下载任务暂停

    down_num = 0
    down_done = 0
    down_size = 0
    down_size_before = 0

    install_num = 0
    install_stop = 0
    installed_app_num = 0

    down_item = None
    install_item = None

    timer = QTimer()
    sp_timer = QTimer()
    # exit_time = QTimer()
    kum_time = QTimer()
    speed_time = QTimer()
    description = ""
    downloading_appname = ""

    firsttime_click_item = True
    pool = ThreadPoolExecutor(max_workers=15)
    click_cancel_btn = False
    kylin_software_properites = False

    def __init__(self, launch_mode, parent=None):
        QWidget.__init__(self, parent)
        # 设置全局异常处理函数
        sys.excepthook = self.global_except_hook

        self.launch_mode = launch_mode
        self.init_log()
        self.init_ui()
        #self.check_singleton()
        self.cu = CommonUtils()
        self.check_service_key()
        self.iface = DbusService()
        self.kus = KylinUpdateService(self)
        self.init_connect()
        self.mutex = threading.RLock()
        self.download_thread = Thread_Download(self)
        self.download_thread.start()

    #
    # 函数：全局异常捕获
    # etype：异常类型
    # value：异常值
    # trace：堆栈信息
    #
    def global_except_hook(self, etype, value, trace):
        msg = traceback.format_exception(etype, value, trace)
        if self.is_log_init == True:
            LogManager.CRI("".join(msg))

        sys.__excepthook__(etype, value, trace)
        self.exit_app(_("Crashed! For details in $HOME/.cache/kum.log"))

    # 函数：初始化UI
    #
    def init_ui(self):
        self.setWindowIcon(QIcon("./res/kylin-update-manager.png"))
        self.setWindowTitle(_("Kylin Update Manager"))
        self.setWindowOpacity(1)
        self.setFocusPolicy(Qt.NoFocus)
        self.resize(LOADINGWIDTH, LOADINGHEIGHT)
        '''
        # 实例阴影shadow
        shadow = QGraphicsDropShadowEffect(self)
        # 设置阴影距离
        shadow.setOffset(0, 0)
        # 设置阴影颜色
        shadow.setColor(QColor("#888888"))
        # 设置阴影圆角
        shadow.setBlurRadius(6)
        # 给嵌套QWidget设置阴影
        self.widget.setGraphicsEffect(shadow)
        # 给垂直布局器设置边距(此步很重要, 设置宽度为阴影的宽度)
        '''
        self.setAutoFillBackground(True)
        self.setWindowFlags(Qt.FramelessWindowHint | Qt.Widget)
        self.setAttribute(Qt.WA_TranslucentBackground)
        self.centralWidget = QWidget(self)

        self.centralWidget.setGeometry(10,10,self.width()-20,self.height()-20)
        self.centralWidget.setObjectName("centralWidget")
        self.centralWidget.setStyleSheet("QWidget#centralWidget{background-color:white}")
        self.bottom_widget = BottomWidget(self.centralWidget)
        self.bottom_widget.hide()

        self.titlebar = TitleBar(self.centralWidget.width(), True, True, _("Kylin Update Manager") + VERSION, self.centralWidget)

        self.titlebar.setGeometry(0, 0, self.titlebar.width(), self.titlebar.height())
        self.titlebar.show()
        self.loading_widget = LoadingWidget(self,self.centralWidget)
        self.loading_widget.setGeometry(0, 40, 550, 280)

        self.update_succuss_widget = UpdateSuccessWidget(self.centralWidget)
        self.update_succuss_widget.hide()
        self.tipwidget = UpdateSuccessWidget(self.centralWidget)
        self.tipwidget.close_btn.clicked.connect(self.tipwidget_hide)
        self.mouse_press = False

        self.animation_msg_box = MessageWidget(_("Updated software is available for this computer."), False)
        self.resize(0, 0)
        self.move_to_center()
        self.show()
        if (self.launch_mode == LaunchMode.MANUAL):
            self.resize(LOADINGWIDTH, LOADINGHEIGHT)
            self.loading_widget.progressBar.hide()
            self.loading_widget.loadinglabel.show()
            self.titlebar.show()
            self.move_to_center()
            self.show_main_window()
        if (self.launch_mode == LaunchMode.AUTOMATIC):
            # self.setWindowFlags(Qt.FramelessWindowHint | Qt.WindowStaysOnTopHint)
            self.resize(LOADINGWIDTH, LOADINGHEIGHT)
            self.loading_widget.progressBar.hide()
            # self.loading_widget.loadinglabel.show()
            self.loading_widget.hide()
            self.move_to_center()
            self.hide()

    '''def paintEvent(self,event):
        painter=QPainter(self)show
        painter.setRenderHint(QPainter.Antialiasing)
        painter.setBrush(QBrush(Qt.white))
        painter.setPen(Qt.transparent)
        rect = self.rect()
        rect.setWidth(rect.width())
        rect.setHeight(rect.height())
        painter.drawRoundedRect(rect, 6, 6)'''

	#
	#函数：阴影
	# 
    def paintEvent(self, event):
        # 阴影
        path = QPainterPath()
        path.setFillRule(Qt.WindingFill)
        pat = QPainter(self)
        pat.setRenderHint(pat.Antialiasing)
        # (opt.palette.base().color())
        pat.fillPath(path, QBrush(Qt.white))

        color = QColor(0, 0, 0, 50)

        for i in range(10):

            i_path = QPainterPath()
            i_path.setFillRule(Qt.WindingFill)
            ref = QRectF(10 - i, 10 - i, self.width() - (10 - i) * 2, self.height() - (10 - i) * 2)
            if i == 0:
                pass
            else:
                i_path.addRoundedRect(ref, 0, 0)
                color.setAlpha(int(150 - i ** 0.5 * 50))
                pat.setPen(color)
                pat.drawPath(i_path)
        # pat.end()

        # 主题
        # ref = QRectF(10, 10, self.width() - 20, self.height() - 20)
        # p = QPainter(self)
        # p.setRenderHint(QPainter.Antialiasing)
        # p.setBrush(Qt.white)
        # p.setPen(Qt.transparent)
        # p.setPen(Qt.NoPen)
        # # p.drawRect(opt.rect)
        # p.drawRoundedRect(ref, 0, 0)

    #
    # 函数：信号槽绑定
    #
    def init_connect(self):
        self.loading_widget.cancel_btn.clicked.connect(self.exit_app)
        self.loading_widget.continue_btn.clicked.connect(self.slot_continue_scan)
        self.titlebar.close_button.clicked.connect(self.slot_click_close_button)
        self.titlebar.min_button.clicked.connect(self.slot_click_min_button)
        self.titlebar.set_button.clicked.connect(self.slot_click_menu_button)
        self.bottom_widget.lw_all_selection.itemClicked.connect(self.slot_click_update_item)
        self.bottom_widget.sp_selection.itemClicked.connect(self.slot_click_sp_update_item)

        self.bottom_widget.layout_all_cb.button_update.clicked.connect(self.slot_click_install_button)
        self.bottom_widget.layout_all_cb.button_cancel.clicked.connect(self.slot_click_cancel_button)
        self.animation_msg_box.quitSignal.connect(self.exit_app)
        self.iface.dbus_process_msg.connect(self.slot_dbus_process_msg)
        self.iface.deb_copy_finish.connect(self.slot_copy_deb_finish)

        self.timer.timeout.connect(self.slot_timeout)
        self.sp_timer.timeout.connect(self.slot_sptimer_timeout)
        # self.exit_time.timeout.connect(self.exit_app)
        self.kum_time.timeout.connect(self.slot_kum_finish_tiomeout)

        self.signal_show_exit.connect(self.show_exit_widget)
        self.change_loading_tiplabel.connect(self.slot_change_tiplabel)
        self.kum_update_finish.connect(self.slot_kum_update_finish)

    #
    # 函数：初始化日志模块
    #
    def init_log(self):
        # log_manager.init_log()
        self.is_log_init = True

    #
    # 函数：保证单例模式
    #
    def check_singleton(self):
        try:
            bus = dbus.SessionBus()
        except:
            LogManager.CRI(_("Dbus Initialize Failed, Program Quit."))
            sys.exit(0)

        # 已有实例在运行，将其显示到前端
        try:
            proxy_obj = bus.get_object(SINTERFACE, SINTERFACES)
            iface = dbus.Interface(proxy_obj, SINTERFACE)
            iface.bring_to_front()
            # 退出重复运行的当前实例
            sys.exit(0)

        # 没有实例在运行，创建一个dbus
        except dbus.DBusException:
            bus_name = dbus.service.BusName(SINTERFACE, bus)
            self.dbusControler = UtilDbus(self, bus_name)

    #
    # 函数：获取麒麟操作系统服务序列号
    #
    def check_service_key(self):
        if (self.cu.is_os_community() == True):
            self.service_key = "kylin"
            self.hash_pwd = "123123"
        else:
            #(_("Geting Service Serial Number..."))
            self.service_key = self.cu.get_service_key()
            self.hash_pwd = self.cu.get_hash_pwd()

            if self.service_key is None:
                LogManager.ERR(_("Get Service Serial Number Failed, Program Quit!"))
                if (self.launch_mode == LaunchMode.AUTOMATIC):
                    self.exit_app(_("Get Service Serial Number Failed, Program Quit!"))
                else:
                    qb = QMessageBox(self)
                    qb.setIcon(QMessageBox.Question)
                    qb.setWindowTitle(_("Authorization file exception"))
                    # qb.setText("当前连接的服务器或光盘中没有完全匹配的软件源。\n是否选择其中的默认软件源进行升级？\n\n这可能会导致未知的后果，请向技服人员确认。")
                    qb.setText(_("Get Service Serial Number Failed, Program Quit!"))
                    qb.addButton(QPushButton(_("OK")), QMessageBox.YesRole)
                    rtn = qb.exec_()
                    self.close()
                    sys.exit(_("Get Service Serial Number Failed, Program Quit!"))

    #
    # 函数：收集客户端信息发送给php服务器
    #
    def pingback(self,_appname = "" , _appversion = "" , _statue = ''):
        host_ip, version, soft_version, host_mac = '','','',''
        appname = _appname
        appversion = _appversion
        statue = _statue
        # 获取本机ip
        try:
            s = socket.socket(socket.AF_INET, socket.SOCK_DGRAM)
            s.connect(('8.8.8.8', 80))
            host_ip = s.getsockname()[0]
        except:
            host_ip = 'Ip failed to get'
        # 获取系统版本
        with open('/etc/lsb-release', 'r') as f:
            for line in f:
                if line.strip().startswith('DISTRIB_KYLIN_RELEASE='):
                    version = line.strip().split('=')
                    version = version[1]
        # 获取软件版本
        output = os.popen('dpkg -l|grep kylin-update-manager').readlines()
        if output:
            soft_version = output[0].strip().split()[2]

        # 获取时间
        nowtime = time.strftime('%Y-%m-%d %H:%M:%S', time.localtime(time.time()))

        # 获取Mac
        mac = uuid.UUID(int=uuid.getnode()).hex[-12:]
        host_mac = ":".join([mac[e:e + 2] for e in range(0, 11, 2)])

        send_data = {'ip': host_ip, 'version': version, 'soft_version': soft_version, 'datetime': nowtime,
                     'host_mac': host_mac,"appname":appname,"appversion":appversion,"status": statue}
        # send_data_urlencode = urllib.parse.urlencode(send_data).encode(encoding="UTF-8")
        try:
            kmg = urllib.parse.urlencode({'ip': host_ip, 'version': version, 'soft_version': soft_version, 'datetime': nowtime,
                     'host_mac': host_mac,'appname': appname, 'appversion':appversion,'serial_number': self.service_key,'status': statue, 'filename': ""})
            # 优先使用内网服务器，再使用外网
            try:
                PINGBACK_INTRANET_URL = "http://" + self.kus.UPDATE_INTRANET_URL + "/kylin-update-manager-server/main.php?"
                url = PINGBACK_INTRANET_URL+kmg
                req = urllib.request.urlopen(url=url)
                urllib.request.urlopen(req)
            except:
                url = PINGBACK_INTERNET_URL+kmg
                req = urllib.request.urlopen(url=url)
                urllib.request.urlopen(req)
        except Exception as e:
            LogManager.WARN(_("Pingback failed.")+str(e))

    #
    # 函数：准备工作
    #
    def pre_work(self):
        # 修复可能出现的dpkg问题，卸载可能存在的SP升级包，完成后由slot_dbus_process_msg() 执行 main_work()
        #(_("executing dpkg configure."))
        self.iface.call_configure_dpkg_by_shell()

    #
    # 函数：主流程
    #
    def main_work(self):
        if os.path.isdir(DOWN_TEMP_PATH) != True:
            os.system("mkdir -p " + DOWN_TEMP_PATH)
        if self.iface.check_software_properties_exists():
            try:
                if not self.iface.call_update_source_temple():
                    if (self.launch_mode == LaunchMode.AUTOMATIC):
                        # self.exit_app("媒介中没有可用的软件源，程序退出.")
                        self.exit_app(_("No upgrade media available"))
                    self.loading_widget.change_layout.emit(_("No upgrade media available"))
                    return
                if self.iface.call_update_source_packages() == 100:
                    self.kylin_software_properites = True
                    self.kus.check_update_type(True)
                    return
                else:
                    if (self.launch_mode == LaunchMode.AUTOMATIC):
                        # self.exit_app("媒介中没有可用的软件源，程序退出.")
                        self.exit_app(_("Sources update failed"))
                    self.loading_widget.change_layout.emit(_("Sources update failed"))
                    return
            except Exception as e:
                if (self.launch_mode == LaunchMode.AUTOMATIC):
                    # self.exit_app("媒介中没有可用的软件源，程序退出.")
                    self.exit_app(_("Sources update failed"))
                self.loading_widget.change_layout.emit(_("Sources update failed"))
                print("源管理器更新源失败:",e)
                return
        if (self.kus.check_available_medium() == True):
            if (self.kus.is_sinfo_down_success == True):
                if (self.kus.is_sinfo_match == True):
                    self.check_status()
                else:
                    qb = QMessageBox(self)
                    qb.setIcon(QMessageBox.Question)
                    qb.setWindowTitle(_("No Matching Source"))
                    qb.setText(_(
                        "The connected server or CD does not have matched software source.\nDo you want to select the default software source to upgrade?\n\nThe operation may cause unknow result, please confirm to technocrat."))
                    qb.setStandardButtons(QMessageBox.Yes | QMessageBox.No)
                    qb.setButtonText(QMessageBox.Yes, str(_("OK")))
                    qb.setButtonText(QMessageBox.No, str(_("Cancel")))
                    rtn = qb.exec_()

                    if (rtn == QMessageBox.Yes):
                        self.check_status()
                    else:
                        self.set_default_sourceslist()
                        self.exit_app(_("User Cancel, Program Quit."))

            # 下载sinfo失败
            else:
                self.set_default_sourceslist()
                if (self.kus.is_sinfo_match == False):
                    if (self.launch_mode == LaunchMode.AUTOMATIC):
                        # self.exit_app("媒介中没有可用的软件源，程序退出.")
                        self.exit_app(_("No software source available, Program Quit."))
                    else:
                        self.loading_widget.change_layout.emit(_("No software source available"))
                else:
                    if (self.launch_mode == LaunchMode.AUTOMATIC):
                        # self.exit_app("下载软件源信息出错，程序退出.")
                        self.exit_app(_("Error when downloading info of software source, Program Quit."))
                    else:
                        self.loading_widget.change_layout.emit(_("Error when downloading info of software source"))
                        # self.clean_sp_widget.emit()

        # 找不到可用的升级媒介
        else:
            self.set_default_sourceslist()

            if (self.launch_mode == LaunchMode.AUTOMATIC):
                self.exit_app(_("No upgrade media available, Program Quit."))
            else:
                self.loading_widget.change_layout.emit(_("No upgrade media available"))
                # self.clean_sp_widget.emit()
    #
    # 函数：检测apt update、自我升级、系统升级
    #
    def check_status(self):
        # 修改sourceslist
        self.available_source = self.kus.available_source
        self.sourcelines = self.kus.get_sources()
        self.iface.change_source_list_to_kylin_update(self.sourcelines)
        # 需要apt-get update
        if (self.kus.check_need_apt_get_update() == True):
            # 执行apt-get update，False代表完成后由slot_dbus_process_msg() 执行 check_update_type()
            self.iface.call_update_source_by_shell(False)
        else:
            self.kus.check_update_type()

    #
    # 函数：任务分支
    #
    def switch_task(self, is_kylin_update, is_kum_update):
        # 可能的apt-get update已完成，告知dbus后台初始化apt库
        # print("kylin:", is_kylin_update, "kum:", is_kum_update)
        self.iface.call_init_cache()
        if self.is_created == False:
            # pyqt缺陷，密集执行函数时初始化trayicon很容易导致trayicon大小异常
            # 不得已将trayicon的初始化放此处，在大部分任务处理完之后
            self.tray_icon = SystemTray(self)
            self.is_created = True

        if (is_kum_update == True):
            self.task_mode = TaskMode.UPDATEKUM
            if (is_kylin_update == True):
                self.has_sp_update = True
        else:
            if (is_kylin_update == True):
                self.task_mode = TaskMode.UPDATEOS
            else:
                self.task_mode = TaskMode.UPDATEPKG

        # 更新管理器自我升级流程
        if (self.task_mode == TaskMode.UPDATEKUM):
            self.change_loading_tiplabel.emit(_("Detected"), True)
            self.is_working_c = True
            self.iface.call_upone("kylin-update-manager")

        # 系统升级流程
        elif (self.task_mode == TaskMode.UPDATEOS):
            # 提示进行系统升级
            self.move_to_center()
            self.show_main_window()
        # 包升级流程
        else:
            self.kus.start_access()

    #
    # 函数：显示自我升级
    #
    def slot_kum_update_finish(self):
        self.loading_widget.loadinglabel.hide()
        self.loading_widget.appname_label.hide()
        self.loading_widget.label1.hide()
        self.loading_widget.update_tip.show()
        self.loading_widget.update_tip.setText(_("Update Succesed."))
        self.loading_widget.tiplabel.setText(_("Automatically restart the update manager in three seconds"))

    #
    # 函数：自我升级完成，退出dbus，重启更新管理器
    #
    def kylin_update_manager_upgrade_finish(self):
        self.kum_update_finish.emit()
        self.kum_time.start(3000)

    #
    # 函数：重启更新管理器
    #
    def slot_kum_finish_tiomeout(self):
        self.kum_time.stop()
        if self.iface:
            self.iface.exit_dbus()

        if self.launch_mode == LaunchMode.AUTOMATIC:
            os.system("kylin-update-manager -auto &")
        else:
            os.system("kylin-update-manager -m &")

        self.close()
        sys.exit("Update Manager Restart.")

    #
    # 函数：修复配置文件冲突，默认选择Yes
    #
    def fix_conffile(self):
        self.iface.call_fix_conffile()

    #
    # 函数：安装kylin-update完成，执行并退出更新管理器
    #
    def kylin_update_install_finish(self):
        if os.path.isfile("/usr/share/kylin-update-desktop/kylin-simpleupdate"):
            os.system("/usr/share/kylin-update-desktop/kylin-simpleupdate &")
        elif os.path.isfile("/tmp/kylin-update/kylin-simpleupdate"):
            os.system("/tmp/kylin-update/kylin-simpleupdate &")
        self.exit_app(_("System upgrade start, Update Manager Quit."))

    #
    # 函数：软件安装完成后，需要拉起的软件运行其启动命令
    #
    def run_software(self):
        for line in RUNLIST:
            run_command = line + " &"
            os.system(run_command)
        self.exit_app(_("Update succeed..."))

    #
    # 函数：将sources.list.kumbak还原为sources.list
    #
    def set_default_sourceslist(self):
        if hasattr(self, "iface"):
            self.iface.change_source_list_to_default()

    '''
    Dbus Apt后台信号统一处理函数
    信号传递顺序：
    daemon.kum_fetch_signal() / kum_apt_signal()
    dbus_service.slot_kum_fetch_signal() / slot_kum_apt_signal()
    self.slot_dbus_process_msg()
    '''

    def slot_dbus_process_msg(self, signal_type, app_name, action, percent, process_type, status):
        # print(app_name, " : ", signal_type, " : ", process_type, " : ", str(percent), " : ", status, " : ", action)
        # conffile冲突
        if process_type == "apt_conffile":
            self.is_conffile = True
        # 错误信号,有conffile时暂不处理
        if process_type == "apt_error" and self.is_conffile == False:
            if app_name == "#update" or app_name == "#update-shell":
                self.set_default_sourceslist()
                LogManager.INFO(_("Update source failed, five seconds later, Program will quit."))
                self.loading_widget.change_layout.emit(_("Update source failed"))
                # self.parent.clean_sp_widget.emit()
            else:
                # 有包无法下载
                if (str(percent) == "-99.0"):
                    msgToShow = status + " " + _("Update software failed, five seconds later, Program will quit.")
                    for i in self.App_Version_list:
                        if i.NAME in app_name:
                            self.get_app_changelog(i,"Fail")
                    LogManager.INFO(msgToShow)
                else:
                    # 升级流程时出错,自动退出.
                    if (self.task_mode == TaskMode.UPDATEOS):
                        LogManager.INFO(_("Update service pack failed, five seconds later, Program will quit."))
                        for i in self.App_Version_list:
                            if i.NAME in app_name:
                                self.get_app_changelog(i,"Fail")
                        # self.get_down_statue(_("Update software failed"), app_name)
                    else:
                        for i in self.App_Version_list:
                            if i.NAME == app_name:
                                self.get_app_changelog(i, "Fail")
                        LogManager.INFO(_("Update software failed, five seconds later, Program will quit."))
                self.remove_pkg_in_list(app_name)
        # 调用本地命令dpkg --configure -a过程的信号
        if app_name == "#configure-shell":
            if process_type == "finish" and str(percent) == "200.0":
                self.change_loading_tiplabel.emit(_("Updating data from source..."), False)
                self.thread_work = Thread_work(self)
                self.thread_work.start()

        # 调用本地命令apt-get update过程的信号
        if app_name == "#update-shell":
            if process_type == "finish" and str(percent) == "200.0":
                print("!!  一次apt-get update完成，模式：", action)
                # 0既传入的False，代表非quiet，开始检测是否有系统版本升级
                if action == "0":
                    self.kus.check_update_type()
        # 调用本地命令fix conffile过程的信号
        if app_name == "#fix-conffile-shell":
            if self.is_working_c == True:
                LogManager.INFO(_("Crucial update successed..."))
                self.is_working_c = False
                self.tray_icon.hide()

                if self.isHidden() == True:
                    self.set_default_sourceslist()
                    self.signal_show_exit.emit(_("Update Succesed."))
            else:
                LogManager.INFO(_("Ordinary and Important update successed..."))
                self.is_working = False
                self.set_default_sourceslist()
                self.signal_show_exit.emit(_("Update Succesed."))
        # 包升级过程的信号
        else:
            # 下载过程
            if signal_type == "fetch":
                if process_type == "down_start":
                    pass
                elif process_type == "down_stop": #下载暂停有可能是包已经安装了，此时不会再次安装，需要从工作列表中移除软件包
                    if self.kus.at.ca[app_name].is_installed and self.kus.at.ca[app_name].is_upgradable == False:
                        self.remove_pkg_in_list(app_name)
                else:
                    if "down_pulse" in process_type:
                        # apt会重复打印信息，过滤掉
                        if process_type != self.previous_process_type:
                            self.previous_process_type = process_type
                    if percent not in [0.0, "0.0", None]:
                        pass
                    #设置右下角下载进度
                    self.set_tray_progress(app_name, _("Download Progress: "), percent)
            # 安装开始
            elif signal_type == "apt" and process_type == "apt_start":
                pass
            # 安装结束
            elif signal_type == "apt" and process_type == "apt_finish" and str(percent) == "100.0" :
                #从列表中移除该软件包
                self.remove_pkg_in_list(app_name)
                #发送进度信号
                self.get_install_progress.emit(app_name, percent)
                #当更新完毕是取消全选的状态 bug71915
                self.bottom_widget.slot_all_select(0)
                self.bottom_widget.slot_h_select(0)
                for i in self.App_Version_list:
                    if i.NAME == app_name:
                        self.get_app_changelog(i,"Success")
                        LogManager.INSTALL(("installed " + app_name + ' ' + i.CANDIDATEVERSION))
                #设置右下角的安装进度信号
                self.set_tray_progress(app_name, _("Install Process:"), str(percent))
                # sp升级完成后启动应用
                if app_name == "kylin-update-desktop":
                    self.kylin_update_install_finish()
                # 如果是更新管理器自升级则退出重启应用
                elif app_name == "kylin-update-manager":
                    self.kylin_update_manager_upgrade_finish()
            # 流程pulse
            else:
                if signal_type == "apt" and process_type == "apt_pulse":
                    self.get_install_progress.emit(app_name, percent)
                    self.set_tray_progress(app_name, _("Install Process:"), str(percent))

    #
    # 函数：设置右下角下载和安装进度
    #
    def set_tray_progress(self, appname, statue, percent):
        self.tray_icon.appname = appname
        self.tray_icon.statue = statue
        self.tray_icon.process_now = str(int(float(percent)))

    #
    # 函数：从重要更新和关键更新的安装列表中移除
    #
    def remove_pkg_in_list(self, appname):
        # 从关键更新和重要更新的列表中移除
        self.kus.at.ca.open()
        if appname in self.crucial_worklist:
            self.crucial_worklist.remove(appname)
            # 检测是否列表中已有其它包已经被安装了，安装了就从列表中移除（实际操作过程中用户可能将依赖包也写入到了crucial字段中）
            for i in self.crucial_worklist:
                if self.kus.at.ca[i].is_installed and self.kus.at.ca[i].is_upgradable == False:
                    self.crucial_worklist.remove(i)
            # 只有关键更新的时候，关键更新完成后退出软件
            if len(self.crucial_worklist) == 0 and self.len_important == 0:
                self.exit_app()
        elif appname in self.important_worklist:
            self.important_worklist.remove(appname)
            for i in self.important_worklist:
                if self.kus.at.ca[i].is_installed and self.kus.at.ca[i].is_upgradable == False:
                    self.important_worklist.remove(i)
        self.kus.at.ca.close()

    #
    # 函数：安装成功后移除item，并刷新界面
    #
    def remove_list(self, appname):
        if self.is_SP_update == True:
            pass
        else:
            i = 0
            while i < self.bottom_widget.lw_all_selection.count():
                item  = self.bottom_widget.lw_all_selection.item(i)
                itemWidget = self.bottom_widget.lw_all_selection.itemWidget(item)
                if itemWidget.app_msg.NAME == appname:
                    remove_item = self.bottom_widget.lw_all_selection.takeItem(i)
                    self.bottom_widget.lw_all_selection.removeItemWidget(remove_item)
                    del remove_item
                i = i + 1
        self.get_app_num -= 1
        self.bottom_widget.layout_h_cb.label_num.setText(str(self.get_app_num))

    #
    # 函数：app_name == "#install_and_upgrade"安装结束，percent = 100%之后的流程
    #
    def update_success(self,ret):
        if self.is_conffile == True:
            self.fix_conffile()
        else:
            if self.is_working_c == True:
                LogManager.INFO(_("Crucial update successed..."))
                self.tray_icon.hide()
                if self.isHidden() == True:
                    if RUNLIST:
                        self.run_software()
                    if (ret == "Success"):
                        self.signal_show_exit.emit(_("Update Succesed."))
                    else:
                        self.signal_show_exit.emit(_("update failed"))
            else:
                LogManager.INFO(_("Ordinary and Important update successed..."))
                self.is_working = False
                if RUNLIST:
                    self.run_software()
                if (ret == "Success"):
                    self.signal_show_exit.emit(_("Update Succesed."))
                else:
                    self.signal_show_exit.emit(_("update failed"))

    #
    # 函数：处理获取changelog
    #
    def get_app_changelog(self,i,statue):
        keyword = ""
        if(i.NAME == "kylin-update-desktop-security" or i.NAME == "安全更新"):
            keyword = "安全更新"
        if (i.NAME == "kylin-update-desktop-support" or i.NAME == "系统基础组件"):
            keyword = "系统基础组件,支撑,系统基础"
        if (i.NAME == "kylin-update-desktop-ukui" or i.NAME == "桌面环境组件"):
            keyword = "桌面环境组件"
        if (i.NAME == "kylin-update-desktop-app" or i.NAME == "基本应用"):
            keyword = "基本应用"
        if (i.NAME == "kylin-update-desktop-kernel" or i.NAME == "系统内核组件"):
            keyword = "系统内核组件"
        if (i.NAME == "kylin-update-desktop-kernel-3a4000" or i.NAME == "系统内核组件"):
            keyword = "系统内核组件"
        if (i.NAME == "kylin-update-desktop-kydroid" or i.NAME == "kydroid补丁包"):
            keyword = "kydroid补丁包"
        install_db = install_information()
        self.pingback(i.NAME,i.CANDIDATEVERSION,statue)
        file_name1 = "/usr/share/doc/" + i.NAME + "/changelog.gz"
        file_name2 = "/usr/share/doc/" + i.NAME + "/changelog.Debian.gz"
        filename = ""
        if (os.path.exists(file_name1)):
            filename = file_name1
        elif (os.path.exists(file_name2)):
            filename = file_name2
        try:
            description = ""
            if (self.kus.available_url.startswith("file") == False):
                cmd = "apt-get changelog " + i.NAME + " > /dev/null 2>&1"
                result = os.popen(cmd).readlines()
                description = self.get_changelog(result, i)
            if description == "":
                if (filename == ""):
                    if (statue == "Fail"):
                        self.check_insert_type(install_db,i.NAME, i.CANDIDATEVERSION,_("Unable to get changelog due to installation failure"),i.ICON, statue,keyword)
                    else:
                        self.check_insert_type(install_db,i.NAME, i.CANDIDATEVERSION, "", i.ICON, statue,keyword)
                    return
                try:
                    read_cmd = "zless "+filename
                    read_result = os.popen(read_cmd).readlines()
                    description = self.get_changelog(read_result, i)
                    self.description = ""
                    self.description = description
                    self.check_insert_type(install_db,i.NAME, i.CANDIDATEVERSION, self.description, i.ICON, statue,keyword)
                except:
                    if(statue == "Fail"):
                        self.check_insert_type(install_db,i.NAME, i.CANDIDATEVERSION, _("Unable to get changelog due to installation failure"), i.ICON, statue,keyword)
                    else:
                        self.check_insert_type(install_db,i.NAME, i.CANDIDATEVERSION, "", i.ICON, statue,keyword)
            else:
                self.description = ""
                self.description = description
                self.check_insert_type(install_db,i.NAME, i.CANDIDATEVERSION, self.description, i.ICON, statue,keyword)
        except:
            if(filename == ""):
                if (statue == "Fail"):
                    self.check_insert_type(install_db,i.NAME, i.CANDIDATEVERSION, _("Unable to get changelog due to installation failure"), i.ICON, statue,keyword)
                else:
                    self.check_insert_type(install_db,i.NAME, i.CANDIDATEVERSION, "", i.ICON, statue,keyword)
                return
            open_cmd = "zless "+filename
            try:
                read_result = os.popen(open_cmd)
                description = self.get_changelog(read_result,i)
                self.description = ""
                self.description = description

                self.check_insert_type(install_db,i.NAME, i.CANDIDATEVERSION, self.description, i.ICON, statue,keyword)
            except:
                if (statue == "Fail"):
                    self.check_insert_type(install_db,i.NAME, i.CANDIDATEVERSION, _("Unable to get changelog due to installation failure"),
                                      i.ICON, statue)
                else:
                    self.check_insert_type(install_db,i.NAME, i.CANDIDATEVERSION, "", i.ICON, statue,keyword)

    def get_changelog(self,result,app_msg):
        k = 0
        description = ""
        for j in result:
            if (app_msg.CANDIDATEVERSION in j):
                while (1):
                    version = re.findall(r'[(](.*?)[)]', result[k])
                    description = description + version[0] + "\n"
                    k = k + 2
                    while (1):
                        if (result[k] != "\n" or result[k] != " \n" or result[k] != "  \n"):
                            result[k].strip("\n")
                            description = description + result[k]
                        k = k + 1
                        if (("--" in result[k]) and ("<" in result[k]) and ("@" in result[k])):
                            break
                    k = k + 2
                    if(k >= len(result) - 1):
                        return description
                    if (app_msg.INSTALLEDVERSION in result[k]):
                        if(app_msg.INSTALLEDVERSION == "" or app_msg.INSTALLEDVERSION==" "):
                            pass
                        else:
                            version = re.findall(r'[(](.*?)[)]', result[k])
                            description = description + version[0] + "\n"
                            k = k + 2
                            while (1):
                                if (result[k] != "\n" or result[k] != " \n" or result[k] != "  \n"):
                                    result[k].strip("\n")
                                    description = description + result[k]
                                k = k + 1
                                if(("--" not in result[k])and ("<" not in result[k]) and ("@" not in result[k])):
                                    break
                            k = k + 2
                            break
        return description

    #
    #函数：插入判断那个表
    #
    def check_insert_type(self,install_db,appname,version,changelog,icon,statue,keyword=""):
        install_db.insert(appname, version, changelog, icon, statue, keyword)
        # if (appname == "kylin-update-manager" or appname == "kylin-update-desktop" or appname == "kylin-update-service"):
        #     install_db.local_insert(appname, version,changelog, icon, statue ,keyword)
        # else:
        #     install_db.insert(appname, version,changelog, icon, statue, keyword)

    #
    # 函数：所有更新信息获取完成
    #
    def slot_access_completed(self, len_o, len_i, crucial_list):
        self.crucial_worklist = crucial_list
        self.len_important = len_i
        # 没有任何更新
        if (len_o == 0 and len_i == 0 and len(crucial_list) == 0):
            self.set_default_sourceslist()
            self.pingback("","",_("information acquisition"))
            if self.launch_mode == LaunchMode.MANUAL:
                self.loading_widget.change_layout.emit(_("No software need updated"))
            else:
                if self.click_cancel == True:
                    self.loading_widget.change_layout.emit(_("No software need updated"))
                else:
                    self.exit_app(_("No updated available."))
        else:
            self.app_num_important = len_i
            self.selected_num_important = len_i

            # 优先安装关键更新
            if (len(crucial_list) > 0):
                if (self.launch_mode == LaunchMode.AUTOMATIC):
                    # self.tray_icon.start_tray_msg("正在执行关键更新.")
                    self.tray_icon.start_tray_msg(_("Installing crucial update."))
                for app in crucial_list:
                    self.c_work_list.append(app)
                    #print(self.c_work_list)
                    self.kus.at.ca.open()
                    app_msg = self.kus.at.ca[app]
                    upkg = UPackage(app_msg,self.kus.at.ca)
                    self.kus.at.fill_info_cn(upkg)
                    self.kus.at.oneAppMsg.emit({"apptype":AppType.CRUCIAL, "displayName":upkg.displayName,
                                                "name":upkg.name, "icon":upkg.icon, "downloadSizeHuman":upkg.downloadSizeHuman,
                                                "downloadSize":upkg.downloadSize, "installedVersion":upkg.installedVersion,
                                                "architecture": app_msg._pkg.architecture,"candidateVersion":upkg.candidateVersion,
                                                "description":upkg.description,"fullversion":upkg.candidateVersion})
                    # 一次性提交所有的关键更新的安装，dbus后台会自动处理
                    self.iface.call_install_and_upgrade(app)
                self.tray_icon.start_tray_msg(_("Installing crucial update."))
            if len_i > 0:
                self.change_display_content(LWMode.IMPORTANT)
            else:
                #此时只有关键更新
                self.hide()

    #
    # 函数：显示继续扫描界面
    #
    def slot_change_layout(self, string):
        self.bottom_widget.hide()
        self.loading_widget.loadinglabel.hide()
        self.loading_widget.tiplabel.hide()
        self.loading_widget.errorlabel.show()
        self.loading_widget.errorlabel.move(155, 95)
        self.loading_widget.errorlabel.setText(string)
        self.loading_widget.cancel_btn.show()
        self.loading_widget.cancel_btn.move(315, 215)
        self.loading_widget.continue_btn.show()
        self.loading_widget.continue_btn.move(430, 215)
        self.loading_widget.setFixedSize(550, 280)
        self.loading_widget.move(0, 40)
        self.loading_widget.show()

    #
    # 函数：清除sp列表
    #
    def slot_clean_spwidget(self):
        self.bottom_widget.sp_selection.clear()

    #
    # 函数：每获得一个app信息
    #
    def slot_get_one_app(self, msg):
        app_msg = AppMsg()
        app_msg.ZH_CN_NAME = msg["displayName"]
        app_msg.NAME = msg["name"]
        app_msg.ICON = msg["icon"]
        app_msg.SIZE = msg["downloadSizeHuman"]
        app_msg.BYTESIZE = msg["downloadSize"]
        app_msg.INSTALLEDVERSION = msg["installedVersion"]
        app_msg.CANDIDATEVERSION = msg["candidateVersion"]
        app_msg.DESCRIPTION = msg["description"]
        app_msg.ARCHITECTURE = msg["architecture"]
        app_msg.FULLVERSION = msg["fullversion"]
        app_msg.TYPE = msg["apptype"]
        # App_Version_dic = {"name": app_msg.NAME, "version": app_msg.CANDIDATEVERSION,"description": app_msg.DESCRIPTION,
        #                    "icon": app_msg.ICON, "architecture": app_msg.ARCHITECTURE,"fullversion": app_msg.FULLVERSION,
        #                    "installversion": app_msg.INSTALLEDVERSION}
        self.App_Version_list.insert(self.App_install_num, app_msg)
        self.App_install_num += 1
        if msg['apptype'] == AppType.ORDINARY:
            self.add_ordinary_item(app_msg)
        elif msg['apptype'] == AppType.IMPORTANT:
            self.add_important_item(app_msg)
        elif msg['apptype'] == AppType.SP:
            self.add_sp_item(app_msg)

    #
    # 函数：搜索
    #
    def slot_textChanged(self):
        self.menu.order_statue = 0
        select_text = self.menu.log_widget.search_line.text()
        self.menu.is_search = False
        self.menu.log_widget.search_widget.setStyleSheet(".QWidget{background-color:#ffffff;border:1px solid #3d6be5;}")
        self.menu.log_widget.search_image.setStyleSheet("QPushButton{background-color:#ffffff;border:0px solid #cfcfcf;font-size:12px;color:#a0a0a0;image: url(./res/close1.png);}")
        #self.menu.log_widget.search_line.setStyleSheet("QLineEdit{border-radius:6px;background-color:white;border:1px solid #3d6be5;color:#444444;font-size:12px;}")
        # self.menu.log_widget.local_infmation_list.clear()
        self.menu.log_widget.app_infmation_list.clear()
        installed_db = install_information()
        installed_db.search_select(select_text)
        self.show_selected_imformation(installed_db)
        self.menu.log_widget.show()

    #
    #函数:将搜索到的信息显示到界面
    #
    def show_selected_imformation(self,installed_db):
        self.menu.res_online = installed_db.cursor.fetchall()
        res = self.menu.res_online
        if res == None:
            installed_db.connect.commit()
            installed_db.cursor.close()
            installed_db.connect.close()
        if (len(res) < 20):
            for item in res:
                self.menu.insert_to_listwidget(item)
            installed_db.connect.commit()
            installed_db.cursor.close()
            installed_db.connect.close()
        else:
            i = 0
            for item in res:
                if (i >= 50):
                    break
                i = i + 1
                self.menu.insert_to_listwidget(item)
            installed_db.connect.commit()
            installed_db.cursor.close()
            installed_db.connect.close()


    #
    # 函数：添加SP包到UI界面
    #
    def add_sp_item(self, app_msg):
        is_SP_update = True
        item = QListWidgetItem()
        list_item = UpdateListItemWidget(app_msg,self)
        self.get_install_progress.connect(list_item.set_install_progress)
        self.start_install_deb.connect(list_item.start_install)
        self.submit_download_task.connect(list_item.start_down)
        self.send_pause_signal.connect(list_item.slot_pause_download)
        list_item.download_progress.setFixedHeight(80)
        list_item.install_progress.setFixedHeight(80)
        list_item.setFixedHeight(80)
        list_item.checkBox.hide()
        list_item.logolabel.setFixedSize(48, 48)
        list_item.logolabel.move(15, 15)
        list_item.applabel.move(83, 5)
        list_item.appdescrible.hide()
        list_item.sizelabel.show()
        list_item.applabel.setStyleSheet("QLabel{font-size:18px;color:#444444;border:0px solid #cfcfcf;}")
        list_item.installed_versionlabel.setText(_("current version:") + app_msg.INSTALLEDVERSION)
        list_item.installed_versionlabel.setStyleSheet("QLabel{font-size:12px;color:#444444;border:0px solid #cfcfcf;}")
        list_item.installed_versionlabel.move(83, 40)
        list_item.new_versionlabel.setText(_("new version:") + app_msg.CANDIDATEVERSION)
        list_item.new_versionlabel.setStyleSheet("QLabel{font-size:12px;color:#444444;border:0px solid #cfcfcf;}")
        list_item.new_versionlabel.move(83, 57)
        list_item.new_versionlabel.show()
        list_item.splitlabel.hide()
        list_item.setStatusTip(str(app_msg.BYTESIZE))
        if "KYDROID" in app_msg.CANDIDATEVERSION.upper().split('-'):
            is_SP_update = False
            list_item.installed_versionlabel.hide()
            list_item.new_versionlabel.move(83, 45)
        item.setWhatsThis(app_msg.DESCRIPTION)
        self.bottom_widget.sp_selection.addItem(item)
        self.bottom_widget.sp_selection.setItemWidget(item, list_item)
        self.item_map[app_msg.NAME] = list_item
        self.get_app_num += 1
        self.change_display_content(LWMode.SP, is_SP_update)

    #
    # 函数：将一个普通app添加到ui
    #
    def add_ordinary_item(self, app_msg):
        item = QListWidgetItem()
        list_item = UpdateListItemWidget(app_msg,self)
        list_item.setStatusTip(str(app_msg.BYTESIZE))
        list_item.installed_versionlabel.hide()
        item.setWhatsThis(app_msg.DESCRIPTION)
        list_item.size_change.connect(self.recalculate_ordinary_apps_size)
        # list_item.checkBox.clicked.connect(self.set_checkbox)
        self.bottom_widget.lw_all_selection.addItem(item)
        self.bottom_widget.lw_all_selection.setItemWidget(item, list_item)
        self.item_map[app_msg.NAME] = list_item
        # item.isSelected.connect(self.slot_select_item(app_msg))

    #
    # 函数：将一个重要app添加到ui
    #
    def add_important_item(self, app_msg):
        item = QListWidgetItem()
        list_item = UpdateListItemWidget(app_msg, self)
        self.get_install_progress.connect(list_item.set_install_progress)
        self.start_install_deb.connect(list_item.start_install)
        self.submit_download_task.connect(list_item.start_down)
        self.send_pause_signal.connect(list_item.slot_pause_download)
        list_item.setStatusTip(str(app_msg.BYTESIZE))
        list_item.installed_versionlabel.hide()
        item.setWhatsThis(app_msg.DESCRIPTION)
        # list_item.size_change.connect(self.recalculate_important_apps_size)
        # list_item.checkBox.clicked.connect(self.set_checkbox)
        self.bottom_widget.lw_all_selection.addItem(item)
        self.bottom_widget.lw_all_selection.setItemWidget(item, list_item)
        self.item_map[app_msg.NAME] = list_item
        self.get_app_num += 1
        # self.bottom_widget.lw_all_selection.itemClicked.connect(self.slot_select_item)
        '''
        update_item = QListWidgetItem()
        update_list_item = downloadwidget(app_msg,False,self)
        self.update_bottom_widget.lw_all_selection.addItem(update_item)
        self.update_bottom_widget.lw_all_selection.setItemWidget(update_item, update_list_item)
        '''

    #
    # 函数：ui内容初始化
    #
    def change_display_content(self, lw_mode, is_SP_update=False):
        # self.top_widget.label_all_num.setText(str(self.app_num_ordinary + self.app_num_important))
        self.bottom_widget.layout_h_cb.label_num.setText(str(self.get_app_num))
        # self.update_bottom_widget.layout_h_cb.label_num.setText(str(self.app_num_important))
        if lw_mode == LWMode.IMPORTANT:
            self.bottom_widget.setFixedSize(550, 560)
            self.bottom_widget.layout_all_cb.move(0, self.bottom_widget.height() - 70)
            self.bottom_widget.lw_all_selection.show()
            self.bottom_widget.layout_all_cb.button_cancel.hide()
            self.bottom_widget.layout_all_cb.cb.show()
            self.bottom_widget.layout_all_cb.label_all_select.show()
            self.bottom_widget.layout_h_cb.cb.show()
            self.bottom_widget.layout_h_cb.label_all_select.setText(_("totality "))
            self.bottom_widget.layout_h_cb.label_2.setText(_(" entries"))
            palette = QPalette()
            palette.setColor(QPalette.Background, QColor(231, 231, 231))
            self.bottom_widget.layout_all_cb.setPalette(palette)
            self.bottom_widget.show_both_title()
            self.show_main_window()
            self.switch_to_list_window()
        elif lw_mode == LWMode.SP:
            # sp包升级时itemlist出现的地方
            self.bottom_widget.sp_selection.setCurrentRow(0)
            first_item = self.bottom_widget.sp_selection.item(0)
            first_item.setSelected(False)
            self.bottom_widget.resize(550, 260)
            self.bottom_widget.sp_selection.show()
            # self.bottom_widget.te_description.setText(first_item.whatsThis())
            self.bottom_widget.show_both_title()
            self.bottom_widget.layout_all_cb.cb.hide()
            self.bottom_widget.layout_h_cb.cb.hide()
            self.bottom_widget.layout_all_cb.label_all_select.hide()
            palette = QPalette()
            palette.setColor(QPalette.Background, QColor(255, 255, 255))
            self.bottom_widget.layout_all_cb.setPalette(palette)
            self.is_SP_update = True
            # self.show_main_window()
            self.switch_to_SP_window()

        else:
            self.bottom_widget.lw_all_selection.setCurrentRow(0)
            first_item = self.bottom_widget.lw_all_selection.item(0)
            # self.bottom_widget.te_description.setText(first_item.whatsThis())
            self.bottom_widget.show_both_title()
            self.show_main_window()
            self.switch_to_list_window()

    #
    # 函数：加减计算所选的普通升级包信息
    #
    def recalculate_ordinary_apps_size(self, size_str, flag):
        if flag:
            self.selected_num_ordinary += 1
        else:
            self.selected_num_ordinary -= 1

        self.top_widget.label_selected_num.setText(str(self.selected_num_ordinary + self.selected_num_important))

    #
    # 函数：加减计算所选的重要升级包信息
    #
    def recalculate_important_apps_size(self, size_str, flag):
        if flag:
            self.selected_num_important += 1
        else:
            self.selected_num_important -= 1

    #
    # 函数：显示到前端
    #
    def show_to_frontend(self):
        if self.isMinimized() == True:
            self.showNormal()
        self.setWindowFlags(Qt.FramelessWindowHint | Qt.WindowStaysOnTopHint | Qt.Widget)
        self.show()
        self.raise_()

    #
    # 函数：重复运行程序
    #
    def single_work(self):
        if self.isHidden() == True:
            if self.launch_mode == LaunchMode.AUTOMATIC:
                self.exit_app()
            #print("已经有一个程序在运行了.")
            # print(_("A daemon is already running."))
            self.signal_show_exit.emit(_("A daemon is already running."))
        else:
            self.show_to_frontend()

    #
    # 函数：退出界面
    #
    def show_exit_widget(self, string):
        if (self.click_cancel_btn == False and (self.item_num < self.get_app_num)):
            self.update_bottom_widget.lw_all_selection.clear()
            self.update_bottom_widget.hide()
            self.get_app_num = self.get_app_num - self.item_num
            self.item_num = 0
            self.change_display_content(self,LWMode.IMPORTANT)
        else:
            try:
                self.down_app.terminate()
            except:
                pass
            try:
                self.down_load_progress.terminate()
                self.cancel_down_deb = True
            except:
                pass
            if self.launch_mode == LaunchMode.AUTOMATIC:
                self.exit_app()
            self.update_succuss_widget.hide()
            #self.exit_time.start(5000)

    #
    # 函数：处理加载时改变加载界面的提示语
    #
    def slot_change_tiplabel(self, string, is_update_kum=False):
        if is_update_kum == False:
            self.loading_widget.tiplabel.setText(string)
        else:
            self.loading_widget.appname_label.show()
            self.loading_widget.label1.show()
            self.loading_widget.tiplabel.setText(string)
            self.loading_widget.appname_label.setText(_("Kylin Update Manager "))
            self.loading_widget.label1.setText(_("have a new version,Updating"))

    #
    # 函数：退出程序
    #
    def exit_app(self, msg=None):
        self.send_pause_signal.emit()
        self.click_cancel_btn = True
        try:
            if not self.kylin_software_properites:
                self.set_default_sourceslist()
        except:
            print("sources is ready restored")
        if (hasattr(self, "kus")):
            try:
                self.kus.at.quit()
            except:
                pass
        if (hasattr(self, "pool")):
            try:
                self.pool.shutdown(False)
            except:
                pass
        # 异常退出时需要判断某些属相是否已经初始化 -lijiang
        if (hasattr(self, "thread_work")):
            try:
                self.thread_work.quit()
            except:
                pass
        if (hasattr(self, "download_thread")):
            try:
                self.download_thread.quit()
            except:
                pass
        if hasattr(self, "iface"):
            try:
                self.iface.exit_dbus()
            except:
                pass
        try:
            fcntl.flock(pidfile, fcntl.LOCK_UN)
        except:
            pass

        #self.close()
        sys.exit(msg)

    #
    # 函数：继续扫描
    #
    def slot_continue_scan(self):
        self.loading_widget.errorlabel.hide()
        self.loading_widget.continue_btn.hide()
        self.loading_widget.cancel_btn.hide()
        self.loading_widget.loadinglabel.show()
        self.loading_widget.tiplabel.show()
        # self.kus.at.quit_thread=True
        self.thread_work.start()

    #
    # 函数：退出程序和dbus后台
    #
    # def exit_app(self, msg=None):
    #     print("self.click_cancel_btn:",self.click_cancel_btn)
    #     self.click_cancel_btn = True
    #     self.set_default_sourceslist()
    #     self.kus.at.quit()
    #     self.pool.shutdown(False)
    #     # 异常退出时需要判断某些属相是否已经初始化 -lijiang
    #     if (hasattr(self, "thread_work")):
    #         self.thread_work.quit()
    #     if (hasattr(self, "download_thread")):
    #         self.download_thread.quit()
    #     if hasattr(self, "iface"):
    #         self.iface.exit_dbus()
    #     self.close()
    #     sys.exit(msg)

    #
    # 函数：切换到SP包升级界面
    #
    def switch_to_SP_window(self):
        self.show()
        self.loading_widget.show()
        self.launch_mode = LaunchMode.MANUAL

        #re = os.popen("lscpu |grep -i 3A3000").readlines()
        if(platform.machine() == 'mips64'):
            self.loading_widget.hide()
            self.bottom_widget.show()
        else:
            self.sp_timer.start(1)

    #
    # 函数：切换到list界面
    #
    def switch_to_list_window(self):
        self.launch_mode = LaunchMode.MANUAL
        if self.launch_mode == LaunchMode.MANUAL:
            self.bottom_widget.sp_selection.hide()
        self.show()
        if (platform.machine() == "mips64"):
            self.resize(self.width(), MAINHEIGHT)
            self.centralWidget.resize(self.width()-20, self.height()-20)
            self.show()
            self.move_to_center()
            self.bottom_widget.show()
            self.loading_widget.hide()
            self.bottom_widget.lw_all_selection.show()
            self.titlebar.setGeometry(0, 0, self.width(), 40)
            self.titlebar.setWindowOpacity(0)
        else:
            self.loading_widget.show()
            #self.move_to_center()
            self.timer.start(1)

    #
    # 函数：处理切换到sp升级列表的动画
    #
    def slot_sptimer_timeout(self):
        self.sp_timer.stop()
        loadingwidget_width = self.loading_widget.width()
        loadingwidget_height = self.loading_widget.height()
        if loadingwidget_height - 1 > 0 and loadingwidget_width - 2 > 0:
            self.loading_widget.hide()
            self.loading_widget.setFixedSize(loadingwidget_width - 2, loadingwidget_height - 1)
            self.loading_widget.move(int((self.width() - loadingwidget_width - 2) / 2), int((
                    self.height() - self.titlebar.height() - loadingwidget_height - 1) / 2 + self.titlebar.height()))
            if self.loading_widget.loadinglabel.height() != 0:
                self.loading_widget.loadinglabel.resize(self.loading_widget.loadinglabel.width() - 10,
                                                        self.loading_widget.loadinglabel.height() - 1)
            self.loading_widget.show()
            self.sp_timer.start(4)
        if loadingwidget_width - 2 == 0 or loadingwidget_height - 1 == 0 or loadingwidget_width - 2 < 0 or loadingwidget_height - 1 < 0:
            self.loading_widget.hide()
            self.bottom_widget.show()

    # 用于处理动画中主窗口变大
    #
    def slot_timeout(self):
        self.timer.stop()
        self.bottom_widget.layout_all_cb.move(0, self.height() - 70 - 80)
        # self.bottom_widget.lw_all_selection.hide()
        # self.bottom_widget.hide()
        #self.move_to_center()
        loadingwidget_width = self.loading_widget.width()
        loadingwidget_height = self.loading_widget.height()
        loadinglabel_width = self.loading_widget.loadinglabel.width()
        loadinglabel_height = self.loading_widget.loadinglabel.height()
        x = self.x()
        y = self.y()
        # if self.launch_mode == LaunchMode.MANUAL:
        if self.width() < MAINWIDTH and self.height() + 4 < MAINHEIGHT:
            self.resize(self.width() + 1, self.height() + 4)
            self.centralWidget.reszie(self.centralWidget.width(), self.centralWidget.height() + 4)
            self.titlebar.setFixedSize(self.width(), 40)
            self.titlebar.close_button.setGeometry(self.titlebar.width() - 34, 4, 30, 30)
            # self.loading_widget.show()
            if loadingwidget_height - 1 >= 0 and loadingwidget_width - 2 >= 0:
                self.loading_widget.setFixedSize(loadingwidget_width - 2, loadingwidget_height - 1)
                self.loading_widget.move(int((self.centralWidget.width() - loadingwidget_width - 3) / 2), int((
                        self.centralWidget.height() - self.titlebar.height() - loadingwidget_height) / 2 + self.titlebar.height()))
                if self.loading_widget.loadinglabel.height() != 0:
                    self.loading_widget.loadinglabel.resize(self.loading_widget.loadinglabel.width() - 10,
                                                            self.loading_widget.loadinglabel.height() - 1)
            self.move(x-1,y-2)
            self.timer.start(10)
        elif self.width() == MAINWIDTH and self.height() + 4 <= MAINHEIGHT:
            self.resize(self.width(), self.height() + 4)
            self.centralWidget.resize(self.centralWidget.width(), self.centralWidget.height() + 4)
            self.titlebar.setFixedSize(self.centralWidget.width(), 40)
            self.titlebar.close_button.setGeometry(self.titlebar.width() - 34, 4, 30, 30)
            self.titlebar.min_button.setGeometry(self.titlebar.width() - 68, 4, 30, 30)
            self.titlebar.set_button.setGeometry(self.titlebar.width() - 102, 4, 30, 30)
            if loadingwidget_height - 2 >= 0 and loadingwidget_width - 4 >= 0:
                self.loading_widget.resize(loadingwidget_width - 6, loadingwidget_height - 3)
                self.loading_widget.move(int((self.centralWidget.width() - loadingwidget_width - 6) / 2), int((
                        self.centralWidget.height() - self.titlebar.height() - loadingwidget_height - 3) / 2 + self.titlebar.height()))
                if loadingwidget_width - 6 == 0 or loadingwidget_height - 3 == 0 or loadingwidget_width - 6 < 0 or loadingwidget_height - 3 < 0:
                    self.loading_widget.hide()
                    # self.bottom_widget.show()
            self.titlebar.setGeometry(0, 0, self.centralWidget.width(), 40)
            self.move(x,y-2)
            self.timer.start(10)
        elif self.width() + 1 < MAINWIDTH and self.height() + 3 >= MAINHEIGHT:
            self.resize(self.width() + 1, MAINHEIGHT)
            self.centralWidget.resize(self.centralWidget.width() + 1, self.centralWidget.height())
            self.titlebar.setFixedSize(self.centralWidget.width(), 40)
            self.titlebar.close_button.setGeometry(self.titlebar.width() - 34, 4, 30, 30)
            self.titlebar.min_button.setGeometry(self.titlebar.width() - 68, 4, 30, 30)
            self.titlebar.set_button.setGeometry(self.titlebar.width() - 102, 4, 30, 30)
            if loadingwidget_height - 2 >= 0 and loadingwidget_width - 4 >= 0:
                self.loading_widget.resize(loadingwidget_width - 6, loadingwidget_height - 3)
                self.loading_widget.move(int((self.centralWidget.width() - loadingwidget_width - 6) / 2), int((
                        self.centralWidget.height() - self.titlebar.height() - loadingwidget_height - 3) / 2 + self.titlebar.height()))
                if loadingwidget_width - 6 == 0 or loadingwidget_height - 3 == 0 or loadingwidget_width - 6 < 0 or loadingwidget_height - 3 < 0:
                    self.loading_widget.hide()
                    # self.bottom_widget.show()
            self.titlebar.setGeometry(0, 0, self.centralWidget.width(), 40)
            self.move(x-1,y)
            self.timer.start(10)
        elif self.width() == MAINWIDTH and (self.height() + 3 > MAINHEIGHT or self.height() < MAINHEIGHT):
            self.resize(self.width(), MAINHEIGHT)
            self.centralWidget.resize(self.centralWidget.width(), MAINHEIGHT - 20)
            self.titlebar.setFixedSize(self.centralWidget.width(), 40)
            self.loading_widget.hide()
            self.titlebar.close_button.setGeometry(self.titlebar.width() - 34, 4, 30, 30)
            self.titlebar.min_button.setGeometry(self.titlebar.width() - 68, 4, 30, 30)
            self.titlebar.min_button.show()
            self.titlebar.set_button.setGeometry(self.titlebar.width() - 102, 4, 30, 30)
            self.titlebar.set_button.show()
            self.bottom_widget.layout_h_cb.show()
            self.bottom_widget.lw_all_selection.show()
            self.bottom_widget.show()
            self.titlebar.setGeometry(0, 0, self.centralWidget.width(), 40)
            self.titlebar.setWindowOpacity(0)
            self.move(x,y)
        elif self.width() == MAINWIDTH and self.height() == MAINHEIGHT:
            self.resize(self.width(), MAINHEIGHT)
            self.centralWidget.resize(self.centralWidget.width(), MAINHEIGHT - 20)
            self.titlebar.setFixedSize(self.centralWidget.width(), 40)
            self.loading_widget.hide()
            self.titlebar.close_button.setGeometry(self.titlebar.width() - 34, 4, 30, 30)
            self.titlebar.min_button.setGeometry(self.titlebar.width() - 68, 4, 30, 30)
            self.titlebar.min_button.show()
            self.titlebar.set_button.setGeometry(self.titlebar.width() - 102, 4, 30, 30)
            self.titlebar.set_button.show()
            self.bottom_widget.lw_all_selection.show()
            self.bottom_widget.show()
            self.titlebar.setGeometry(0, 0, self.centralWidget.width(), 40)
            self.titlebar.setWindowOpacity(0)
            self.move(x,y)
            # self.timer.start(5)
        # self.mainGroup.start()

    #
    # 函数：窗口居中
    #
    def move_to_center(self):
        windowWidth = QApplication.desktop().screenGeometry(0).width()
        windowHeight = QApplication.desktop().screenGeometry(0).height()
        self.move(int((windowWidth - self.width()) / 2), int((windowHeight - self.height()) / 2))

    #
    # 函数：显示主界面
    #
    def show_main_window(self):
        #self.move_to_center()
        self.show()
        self.raise_()

    #
    # 函数：最小化界面
    #
    def slot_click_min_button(self):
        self.showMinimized()

    #
    # 函数：点击关闭
    #
    def slot_click_close_button(self):
        self.click_cancel_btn = True
        # 正在执行关键更新，且没有重要更新，点击关闭则hide主界面
        # print("crucial_worklist:",self.crucial_worklist, "important_worklist:", self.important_worklist)
        if len(self.crucial_worklist) != 0 and len(self.important_worklist) == 0:
            self.hide()
        else:
            # 此时存在重要更新需要提示：更新未完成，请稍等
            if(len(self.important_worklist) > 0):
                self.click_cancel_btn = False
                # self.animation_msg_box.set_animation_args("更新未完成，请稍等.", False)
                self.animation_msg_box.set_animation_args(_("Updating, Please wait."), False)
                self.animation_msg_box.showAnimation(3000)
            # 关键更新和重要更新均没有此时关闭
            elif len(self.important_worklist) == 0 and len(self.crucial_worklist) == 0:
                self.exit_app()

    #
    # 函数：点击更新结束界面的关闭按钮
    #
    def slot_click_tip_close_button(self):
        self.exit_app()

    #
    # 函数：点击设置
    #
    #
    def slot_click_menu_button(self):
        self.get_pos.emit()
        if self.click_config == True:
            self.click_config = False
            self.menu.hide()

        else:
            self.click_config = True
            if(self.menu_init == False):
                self.menu = Menubar(self.width(), self.height(), self.x(), self.y(), self)
                self.menu_init = True
            self.menu.move(338 + self.x(), 5 + self.y())
            self.menu.time.start(int(0.2))
            self.menu.show()
            self.menu.clicked_btn_statue.connect(self.slot_handle_config_signal)
            self.menu.leave_btn.connect(self.slot_leave_menu_signal)
            self.get_pos.connect(self.get_point)

    # 函数:信号处理函数,点击了设置按钮
    def slot_handle_config_signal(self, re):
        if re == True:
            self.click_config = False

    def slot_leave_menu_signal(self):
        self.click_config = False
        self.menu.hide()

    # 获取鼠标的位置
    def get_point(self):
        x1 = self.titlebar.set_button.x()
        y1 = self.titlebar.set_button.y()
        w1 = self.titlebar.set_button.width()
        h1 = self.titlebar.set_button.height()
        x2 = self.menu.x()
        y2 = self.menu.y()
        w2 = self.menu.width()
        h2 = self.menu.height()
        x = QCursor.pos().x() - self.x()
        y = QCursor.pos().y() - self.y()
        if ((((x1 >= x) or (x1 + w1 <= x)) and ((x2 >= x) or (x2 + w2 <= x))) or (
                ((y1 >= y) or (y >= y1 + h1)) and ((y2 >= y) or (y2 + h2 <= y)))):
            self.menu.hide()
            self.click_config = False

    #
    # 函数：点击安装
    #
    def slot_click_install_button(self):
        if self.is_SP_update:
            self.bottom_widget.layout_all_cb.button_update.setEnabled(False)
            self.bottom_widget.layout_all_cb.button_cancel.setEnabled(False)
            self.bottom_widget.layout_all_cb.button_update.setStyleSheet(
                "QPushButton{border-radius:4px;background-color:#e9e9e9;color:#c1c1c1;font-size:16px;}")
            self.bottom_widget.layout_all_cb.button_cancel.setStyleSheet(
                "QPushButton{border-radius:4px;background-color:#e9e9e9;color:#c1c1c1;font-size:16px;}")
        self.submit_download_task.emit()

    #
    # 函数：调用下载任务
    #
    def slot_set_progress_speed(self, appname, progress, speed):
        if self.is_SP_update:
            item = self.bottom_widget.sp_selection.item(0)
            itemWidget = self.bottom_widget.sp_selection.itemWidget(item)
            itemWidget.set_download_speed_progress(progress, speed)
        else:
            for i in range(self.bottom_widget.lw_all_selection.count()):
                item = self.bottom_widget.lw_all_selection.item(i)
                itemWidget = self.bottom_widget.lw_all_selection.itemWidget(item)
                if appname == itemWidget.app_msg.NAME:
                    itemWidget.set_download_speed_progress(progress, speed)

    #
    # 函数：调用拷贝包的函数
    #
    def slot_copy_pkg_to_archive(self, appname):
        if self.is_SP_update:
            item = self.bottom_widget.sp_selection.item(0)
            itemWidget = self.bottom_widget.sp_selection.itemWidget(item)
            itemWidget.copy_pkg_to_archive()
        else:
            for i in range(self.bottom_widget.lw_all_selection.count()):
                item = self.bottom_widget.lw_all_selection.item(i)
                itemWidget = self.bottom_widget.lw_all_selection.itemWidget(item)
                if appname == itemWidget.app_msg.NAME:
                    itemWidget.copy_pkg_to_archive()
        # self.download_thread.task.copy_pkg_to_archive()

    #
    # 函数：关闭至少选择一项更新界面
    #
    def tipwidget_hide(self):
        self.tipwidget.hide()

    #
    # 函数：拷贝结束后发送开始安装的信息
    #
    def slot_copy_deb_finish(self, appname):
        self.start_install_deb.emit(appname)

    #
    # 函数：显示网络连接异常
    #
    def show_network_abnormal(self):
        self.send_pause_signal.emit()
        qb = QMessageBox(self)
        qb.setIcon(QMessageBox.Question)
        qb.setWindowTitle(_("Network anomalies"))
        qb.setText(_("Abnormal disconnected network or server"))
        qb.addButton(QPushButton(_("OK")), QMessageBox.YesRole)
        rtn = qb.exec_()

    #
    # 函数：点击取消
    #
    def slot_click_cancel_button(self):
        self.click_cancel = True
        self.get_app_num = 0
        self.work_list = []
        self.is_SP_update = False
        self.bottom_widget.sp_selection.hide()
        self.bottom_widget.sp_selection.clear()
        self.task_mode = TaskMode.UPDATEPKG
        self.check_update_thread = Thread_check_update(self)
        self.check_update_thread.start()
        # self.bottom_widget.timer.start(1)

    #
    # 函数：点击SP包升级元素
    #
    def slot_click_sp_update_item(self, item):
        get_widget = self.bottom_widget.sp_selection.itemWidget(item)
        self.show_SP_detail_widget(get_widget)

    def slot_click_sp_install_item(self, item):
        get_widget = self.update_bottom_widget.sp_selection.itemWidget(item)
        self.show_SP_detail_widget(get_widget)

    def show_SP_detail_widget(self,get_widget):
        if self.firsttime_click_item == True:
            self.firsttime_click_item = False
            self.app_details = appdetails(get_widget, self)
            self.app_details.top_widget.applogolabel.setFixedSize(48, 48)
            self.app_details.top_widget.appnamelabel.move(75, 17)
            self.app_details.top_widget.appversionlabel.move(75, 45)
            self.app_details.descriplabel.clear()
            self.app_details.descriplabel.setText(get_widget.description)
            self.app_details.move(int(self.x() + (self.width() - self.app_details.width()) / 2),int(self.y() + (self.height() - self.app_details.height()) / 2))
            self.app_details.show()
        else:
            self.app_details.top_widget.applogolabel.clear()
            pixmap = QPixmap(get_widget.app_msg.ICON)
            if pixmap.isNull():
                pixmap = QPixmap("./res/soft_logo.png")
            self.app_details.top_widget.applogolabel.setPixmap(pixmap)
            self.app_details.top_widget.appnamelabel.clear()
            self.app_details.top_widget.appnamelabel.setText(get_widget.app_msg.NAME)
            self.app_details.top_widget.appversionlabel.clear()
            self.app_details.top_widget.appversionlabel.setText(_("version:") + get_widget.app_msg.CANDIDATEVERSION)
            self.app_details.descriplabel.clear()
            self.app_details.descriplabel.setText(get_widget.description)
            self.app_details.move(int(self.x() + (self.width() - self.app_details.width()) / 2),
                                  int(self.y() + (self.height() - self.app_details.height()) / 2))
            self.app_details.show()

    #
    # 函数：点击软件包升级元素
    #
    def slot_click_update_item(self, item):
        get_widget = self.bottom_widget.lw_all_selection.itemWidget(item)
        self.show_app_detail_widget(get_widget)

    def show_app_detail_widget(self,get_widget):
        if self.firsttime_click_item == True:
            self.firsttime_click_item = False
            self.app_details = appdetails(get_widget,self)
            self.app_details.descriplabel.clear()
            self.app_details.descriplabel.setText(get_widget.description)
            self.app_details.move(int(self.x() + (self.width() - self.app_details.width()) / 2),
                                  int(self.y() + (self.height() - self.app_details.height()) / 2))
            self.app_details.show()
        else:
            self.app_details.top_widget.applogolabel.clear()
            pixmap = QPixmap(get_widget.app_msg.ICON)
            if pixmap.isNull():
                pixmap = QPixmap("./res/soft_logo.png")
            self.app_details.top_widget.applogolabel.setPixmap(pixmap)
            #self.app_details.top_widget.appnamelabel.clear()
            #self.app_details.top_widget.appnamelabel.setText(get_widget.app_msg.NAME)
            self.app_details.top_widget.appnamelabel.setText(get_widget.applabel.text())
            self.app_details.top_widget.appversionlabel.clear()
            self.app_details.top_widget.appversionlabel.setText(_("version:") + get_widget.app_msg.CANDIDATEVERSION)
            self.app_details.descriplabel.clear()
            self.app_details.descriplabel.setText(get_widget.description)
            self.app_details.move(int(self.x() + (self.width() - self.app_details.width()) / 2),
                                  int(self.y() + (self.height() - self.app_details.height()) / 2))
            self.app_details.show()

    #
    # 函数：实现无标题栏窗口拖动
    #
    def mousePressEvent(self, event):
        if (event.button() == Qt.LeftButton):
            self.get_pos.emit()
            self.mouse_press = True
            self.drag_pos = event.globalPos() - self.pos()
            event.accept()

    def mouseReleaseEvent(self, event):
        self.mouse_press = False
        self.setWindowOpacity(1)

    def mouseMoveEvent(self, event):
        if (self.mouse_press):
            self.move_pos = event.globalPos()
            self.move(self.move_pos - self.drag_pos)
            self.setWindowOpacity(1)
            event.accept()

    #
    # 函数：鼠标右键点击关闭
    #
    def closeEvent(self, event):
        self.exit_app()

pidfile=0
def app_instance():
    global pidfile
    # homePath = QStandardPaths.standardLocations(QStandardPaths.HomeLocation)
    # pidfile = open(str(homePath[0]+ "/.config/kylin-update-manager%1.lock").replace("%1",os.getenv("DISPLAY")),"w+")
    pidfile = open(os.path.realpath(__file__), "r")
    try:
        fcntl.flock(pidfile, fcntl.LOCK_EX | fcntl.LOCK_NB)
    except:
        print("can't get the file lock")
        sys.exit(0)


def main():
    os.environ["DISPLAY"] = ":0"
    cmd = "dpkg -l | grep libqt5gui | awk '{print $3}'"
    version=os.popen(cmd).readline().strip("\n")
    if version.startswith("5.6"):
        if ("~" in version):
            if ("k" in version.split("~")[1]):
                if (float(version.split("~")[1].split("k")[1]) >= 4):
                    QApplication.setAttribute(Qt.AA_EnableHighDpiScaling)
                    QApplication.setAttribute(Qt.AA_UseHighDpiPixmaps)
    else:
        QApplication.setAttribute(Qt.AA_EnableHighDpiScaling)
        QApplication.setAttribute(Qt.AA_UseHighDpiPixmaps)
    app = QApplication(sys.argv)
    globalfont = QFont()
    globalfont.setPixelSize(14)
    globalfont.setFamily("方正黑体_GBK")
    app.setFont(globalfont)

    app.setOrganizationName("Kylin")
    app.setOrganizationDomain("kylinos.cn")
    app.setApplicationName("kylin-update-manager")
    app_instance()
    # 获取启动参数
    if (len(sys.argv) == 1):
        MainWindow(LaunchMode.MANUAL)
        sys.exit(app.exec_())
    elif (len(sys.argv) == 2):
        if (sys.argv[1] == "-m"):
            MainWindow(LaunchMode.MANUAL)
            sys.exit(app.exec_())
        elif (sys.argv[1] == "-auto"):
            MainWindow(LaunchMode.AUTOMATIC)
            sys.exit(app.exec_())
        else:
            # print "参数错误...", sys.argv
            print(_("Parameter Error..."), sys.argv)
    else:
        print(_("Parameter Error..."), sys.argv)


if __name__ == '__main__':
    main()
