#!/usr/bin/python3
# -*- coding: utf-8 -*-
from PyQt5.QtCore import *
from PyQt5.QtGui import *
from PyQt5.QtWidgets import QWidget, QTextEdit, QVBoxLayout, QDesktopWidget, QListWidget, QLineEdit, QComboBox, QMenu,QMenuBar, QAction
from utils.db_install_information import *
from utils.enums import AppMsg
from mainui.systembutton import *
from mainui.titlebar import *
from mainui.menubar import *

import gettext

gettext.textdomain("kylin-update-manager")

_ = gettext.gettext

class LogWidget(QWidget):
    online_btn_clicked = True
    local_btn_clicked =False
    change_logwidget_show = pyqtSignal(dict)

    def __init__(self, parent=None):

        self.m_parent = parent
        super(LogWidget, self).__init__(parent)
        self.mouse_press = False
        self.init_ui()
        self.init_connect()
        self.init_stylesheet()

    def init_ui(self):
        self.setFixedSize(470,570)
        self.setWindowFlags(Qt.FramelessWindowHint | Qt.Tool)
        self.setAttribute(Qt.WA_TranslucentBackground)
        self.setWindowTitle(_("Kylin Update Manager"))
        palette = QPalette()
        palette.setColor(QPalette.Background, QColor(255, 255, 255))
        self.setPalette(palette)
        self.widget_name_label = QLabel(self)
        self.widget_name_label.setFixedWidth(50)
        self.widget_name_label.move(25,25)
        self.widget_name_label.setStyleSheet("QLabel{font-size:16px;color:#444444;border:0px solid #cfcfcf;}")
        self.widget_name_label.setText(_("Log"))
        self.search_widget = QWidget(self)
        self.search_widget.setFixedSize(200,22)
        self.search_widget.move(74,25)
        self.search_widget.setStyleSheet(".QWidget{background-color:#ffffff;border:1px solid #d9d9d9;}")
        self.search_line = QLineEdit(self.search_widget)
        self.la = QLabel(self)
        self.search_line.setFixedSize(179,20)
        self.search_line.setPlaceholderText(_("search"))
        self.search_line.move(1,1)
        self.search_image = QPushButton(self.search_widget)
        self.search_image.setFocusPolicy(Qt.NoFocus)
        self.search_image.setFixedSize(20,20)
        self.search_image.move(179,1)
        self.search_image.setStyleSheet("QPushButton{background-color:#ffffff;border:none;font-size:12px;color:#a0a0a0;image: url(./res/search.png);}")
        self.search_line.show()
        self.close_button = SystemButton(False, False, True, self)
        self.close_button.setGeometry(self.width() - 44, 14, 30, 30)
        self.close_button.show()
        self.online_btn = QPushButton(self)
        self.online_btn.setFocusPolicy(Qt.NoFocus)
        self.online_btn.setFixedWidth(70)
        self.online_btn.setText(_("Details"))
        self.online_btn.setStyleSheet("QPushButton{background-color:#ffffff;border:none;font-size:16px;color:#3d6be5;}")
        self.online_btn.move(20,70)
        self.online_btn.show()
        self.line1_label = QLabel(self)
        self.line1_label.setFixedSize(70,3)
        self.line1_label.move(20,93)
        self.line1_label.setStyleSheet("QLabel{background-color:#3d6be5;border:0px solid #cfcfcf;}")
        self.line1_label.show()
        self.line2_label = QLabel(self)
        self.line2_label.setFixedSize(55,1)
        self.line2_label.move(90,95)
        self.line2_label.setStyleSheet("QLabel{background-color:#cfcfcf;border:0px solid #cfcfcf;}")
        self.line2_label.show()
        # self.local_btn = QPushButton(self)
        # self.local_btn.setFocusPolicy(Qt.NoFocus)
        # self.local_btn.setFixedWidth(70)
        # self.local_btn.setText(_("local"))
        # self.local_btn.setStyleSheet("QPushButton{background-color:#ffffff;border:none;font-size:16px;color:#444444;}")
        # self.local_btn.move(145, 70)
        # self.local_btn.hide()
        self.line3_label = QLabel(self)
        self.line3_label.setFixedSize(70, 1)
        self.line3_label.move(145, 95)
        self.line3_label.setStyleSheet("QLabel{background-color:#cfcfcf;border:0px solid #cfcfcf;}")
        self.line3_label.show()
        self.line4_label = QLabel(self)
        self.line4_label.setFixedSize(235, 1)
        self.line4_label.move(215, 95)
        self.line4_label.setStyleSheet("QLabel{background-color:#cfcfcf;border:0px solid #cfcfcf;}")
        self.line4_label.show()
        self.linewidget = Line_Widget(self)
        self.linewidget.move(20,98)
        self.linewidget.show()
        self.app_infmation_list = QListWidget(self)
        self.app_infmation_list.setFrameShape(QFrame.NoFrame)
        self.app_infmation_list.setFocusPolicy(Qt.NoFocus)
        self.app_infmation_list.setSpacing(0)
        self.app_infmation_list.setFixedSize(430, 434)
        self.app_infmation_list.move(20, 124)
        self.app_infmation_list.show()
        self.local_infmation_list = QListWidget(self)
        self.local_infmation_list.setFrameShape(QFrame.NoFrame)
        self.local_infmation_list.setFocusPolicy(Qt.NoFocus)
        self.local_infmation_list.setSpacing(0)
        self.local_infmation_list.setFixedSize(430, 434)
        self.local_infmation_list.move(20, 124)
        self.local_infmation_list.hide()


    #
    #函数：信号槽的绑定
    #
    def init_connect(self):
        self.close_button.clicked.connect(self.slot_clicked_close_btn)
        self.online_btn.clicked.connect(self.slot_click_online_btn)
        # self.local_btn.clicked.connect(self.slot_click_local_btn)

    #
    #函数：样式初始化
    #
    def init_stylesheet(self):
        self.search_line.setStyleSheet("QLineEdit{border-radius:6px;background-color:white;border:0px solid #cfcfcf;color:#666666;font-size:12px;}")
        self.app_infmation_list.setStyleSheet("QListWidget{background-color:white;border:0px solid #cfcfcf;}QListWidget::item{background-color:white;height:85px;margin-top:0px;border:0px solid #cfcfcf;}QListWidget::item:hover{background-color:#DAE3FA;}")
        self.app_infmation_list.verticalScrollBar().setStyleSheet("QScrollBar:vertical{margin:0px 0px 0px 0px;background-color:rgb(255,255,255,100);border:0px;width:6px;}\
                                                                         QScrollBar::sub-line:vertical{subcontrol-origin:margin;border:0px solid red;height:13px}\
                                                                         QScrollBar::up-arrow:vertical{subcontrol-origin:margin;background-color:rgba(0,0,0,0);height:13px}\
                                                                         QScrollBar::sub-page:vertical{background-color:#EEEDF0;}\
                                                                         QScrollBar::handle:vertical{background-color:rgba(0,0,0,20%);width:6px;border-radius:6px;} QScrollBar::handle:vertical:hover{background-color:rgb(0,0,0,10%);opacity:0.1;width:6px;border-radius:6px;}  QScrollBar::handle:vertical:pressed{background-color:rgb(0,0,0,50%);width:6px;border-radius:6px;}\
                                                                         QScrollBar::add-page:vertical{background-color:#EEEDF0;}\
                                                                         QScrollBar::down-arrow:vertical{background-color:rgba(0,0,0,0);}\
                                                                         QScrollBar::add-line:vertical{subcontrol-origin:margin;border:0px solid green;height:13px}")

        self.local_infmation_list.setStyleSheet(
            "QListWidget{background-color:white;border:0px solid #cfcfcf;}QListWidget::item{background-color:white;height:85px;margin-top:0px;border:0px solid #cfcfcf;}QListWidget::item:hover{background-color:#DAE3FA;}")
        self.local_infmation_list.verticalScrollBar().setStyleSheet("QScrollBar:vertical{margin:0px 0px 0px 0px;background-color:rgb(255,255,255,100);border:0px;width:6px;}\
                                                                                 QScrollBar::sub-line:vertical{subcontrol-origin:margin;border:0px solid red;height:13px}\
                                                                                 QScrollBar::up-arrow:vertical{subcontrol-origin:margin;background-color:rgba(0,0,0,0);height:13px}\
                                                                                 QScrollBar::sub-page:vertical{background-color:#EEEDF0;}\
                                                                                 QScrollBar::handle:vertical{background-color:rgba(0,0,0,20%);width:6px;border-radius:6px;} QScrollBar::handle:vertical:hover{background-color:rgb(0,0,0,10%);opacity:0.1;width:6px;border-radius:6px;}  QScrollBar::handle:vertical:pressed{background-color:rgb(0,0,0,50%);width:6px;border-radius:6px;}\
                                                                                 QScrollBar::add-page:vertical{background-color:#EEEDF0;}\
                                                                                 QScrollBar::down-arrow:vertical{background-color:rgba(0,0,0,0);}\
                                                                                 QScrollBar::add-line:vertical{subcontrol-origin:margin;border:0px solid green;height:13px}")

    #
    #函数：点击关闭按钮
    #
    def slot_clicked_close_btn(self):
        self.hide()

    #
    #函数：处理点击在线更新按钮
    #
    def slot_click_online_btn(self):
        self.local_infmation_list.hide()
        self.app_infmation_list.show()
        self.online_btn_clicked = True
        self.online_btn.setStyleSheet("QPushButton{background-color:#ffffff;border:0px solid #cfcfcf;font-size:16px;color:#3d6be5;}")
        self.line1_label.setFixedHeight(3)
        self.line1_label.move(20,93)
        self.line1_label.setStyleSheet("QLabel{background-color:#3d6be5;border:0px solid #cfcfcf;}")
        if(self.local_btn_clicked == True):
            self.local_btn.setStyleSheet("QPushButton{background-color:#ffffff;border:0px solid #cfcfcf;font-size:16px;color:#444444;}")
            self.line3_label.setFixedSize(70, 1)
            self.line3_label.move(145, 95)
            self.line3_label.setStyleSheet("QLabel{background-color:#cfcfcf;border:0px solid #cfcfcf;}")
            self.local_btn_clicked = False

    #
    # 函数：处理点击本地更新按钮
    #
    # def slot_click_local_btn(self):
    #     self.local_infmation_list.show()
    #     self.app_infmation_list.hide()
    #     self.local_btn_clicked = True
    #     self.local_btn.setStyleSheet("QPushButton{background-color:#ffffff;border:0px solid #cfcfcf;font-size:16px;color:#3d6de5;}")
    #     self.line3_label.setFixedHeight(3)
    #     self.line3_label.move(145, 93)
    #     self.line3_label.setStyleSheet("QLabel{background-color:#3d6be5;border:0px solid #cfcfcf;}")
    #     if(self.online_btn_clicked ==True):
    #         self.online_btn.setStyleSheet("QPushButton{background-color:#ffffff;border:0px solid #cfcfcf;font-size:16px;color:#444444;}")
    #         self.line1_label.setFixedSize(70, 1)
    #         self.line1_label.move(20, 95)
    #         self.line1_label.setStyleSheet("QLabel{background-color:#cfcfcf;border:0px solid #cfcfcf;}")
    #         self.online_btn_clicked = False

    # 鼠标点击、释放和移动事件
    def mousePressEvent(self, event):
        if (event.button() == Qt.LeftButton):
            self.mouse_press = True
            self.drag_pos = event.globalPos() - self.pos()
            event.accept()

    def mouseReleaseEvent(self, event):
        self.mouse_press = False
        self.setWindowOpacity(1)

    def mouseMoveEvent(self, event):
        if (self.mouse_press):
            self.move_pos = event.globalPos()
            self.move(self.move_pos - self.drag_pos)
            self.setWindowOpacity(1)
            event.accept()

    def paintEvent(self, event):
        # 阴影
        path = QPainterPath()
        path.setFillRule(Qt.WindingFill)
        pat = QPainter(self)
        pat.setRenderHint(pat.Antialiasing)
        # print(opt.palette.base().color())
        pat.fillPath(path, QBrush(Qt.white))

        color = QColor(0, 0, 0, 50)

        for i in range(10):

            i_path = QPainterPath()
            i_path.setFillRule(Qt.WindingFill)
            ref = QRectF(10 - i, 10 - i, self.width() - (10 - i) * 2, self.height() - (10 - i) * 2)
            if i == 0:
                pass
            else:
                i_path.addRoundedRect(ref, 0, 0)
                color.setAlpha(int(150 - i ** 0.5 * 50))
                pat.setPen(color)
                pat.drawPath(i_path)

        # 主题
        ref = QRectF(10, 10, self.width() - 20, self.height() - 20)
        p = QPainter(self)
        p.setRenderHint(QPainter.Antialiasing)
        p.setBrush(Qt.white)
        p.setPen(Qt.transparent)
        p.setPen(Qt.NoPen)
        # p.drawRect(opt.rect)
        p.drawRoundedRect(ref, 0, 0)

class Line_Widget(QWidget):

    def __init__(self, parent=None):

        self.m_parent = parent
        super(Line_Widget, self).__init__(parent)
        self.setAutoFillBackground(True)
        self.setFixedSize(430,26)
        palette = QPalette()
        palette.setColor(QPalette.Background, QColor(239, 240, 239))
        self.setPalette(palette)
        self.initui()


    def initui(self):
        self.appname_label = QLabel(self)
        self.appname_label.setFixedSize(220,26)
        self.appname_label.setText(_("Package name"))
        self.appname_label.setStyleSheet("QLabel{background-color:#eff0ef;border:0px solid #cfcfcf;font-size:12px;color:#a0a0a0;}")
        self.appname_label.move(5,0)
        self.appname_label.show()
        self.select_menu = QLabel(self)
        self.select_menu.setFixedSize(60,26)
        self.select_menu.move(270,0)
        self.select_menu.setStyleSheet("QLabel{background-color:#eff0ef;border:0px solid #cfcfcf;font-size:12px;color:#a0a0a0;}")
        self.select_menu.setText(_("Success or failure"))
        self.select_menu.setFixedSize(50,26)
        self.order_selection = QWidget(self)
        self.order_selection.setFixedSize(60, 26)
        self.order_selection.move(345, 0)
        palette = QPalette()
        palette.setColor(QPalette.Background, QColor(239, 240, 239))
        self.order_selection.setPalette(palette)
        self.label_text = QPushButton(self.order_selection)
        self.label_text.setFocusPolicy(Qt.NoFocus)
        self.label_text.setStyleSheet("QPushButton{background-color:#eff0ef;border:0px solid #cfcfcf;font-size:12px;color:#a0a0a0;}")
        self.label_text.setText(_("Time"))
        self.label_text.setFixedSize(50, 26)
        self.label_text.move(0, 0)
        self.label_image = QPushButton(self.order_selection)
        self.label_image.setFocusPolicy(Qt.NoFocus)
        self.label_image.setStyleSheet(
            "QPushButton{background-color:#eff0ef;border:0px solid #cfcfcf;font-size:12px;color:#a0a0a0;image: url(./res/down.png);}")
        self.label_image.setFixedSize(10, 26)
        self.label_image.move(50, 0)

class Down_Menu(QWidget):
    def __init__(self, parent=None):

        self.m_parent = parent
        super(Down_Menu, self).__init__(parent)
        self.setAutoFillBackground(True)
        self.setFixedSize(50,44)
        palette = QPalette()
        palette.setColor(QPalette.Background, QColor(239, 240, 239))
        self.setPalette(palette)
        self.initui()

    def initui(self):
        self.first_item = QPushButton(self)
        self.first_item.setFixedSize(50,22)
        self.first_item.move(0,0)
        self.first_item.setStyleSheet("QPushButton{color:#a0a0a0;background-color:#cfcfcf;font-size:12px;border:0px solid #cfcfcf;}")
        self.first_item.show()
        self.second_item = QPushButton(self)
        self.second_item.setFixedSize(50, 22)
        self.second_item.move(0,22)
        self.second_item.setStyleSheet("QPushButton{color:#a0a0a0;background-color:#cfcfcf;font-size:12px;border:0px solid #cfcfcf;}")
        self.second_item.show()

    #
    # 函数：鼠标离开事件
    #
    def leaveEvent(self, event):
        self.status = BUTTON_LEAVE
        self.hide()

    #
    # 函数：鼠标按下事件
    #
    def mousePressEvent(self, event):
        if event.button() == Qt.LeftButton:
            self.status = BUTTON_PRESSED
        else:
            event.ignore()

    #
    # 函数：鼠标释放事件
    #
    def mouseReleaseEvent(self, event):
        if event.button() == Qt.LeftButton:
            # 判断鼠标是否点击在这个按钮
            if self.rect().contains(event.pos()):
                self.status = BUTTON_ENTER
            else:
                self.status = BUTTON_LEAVE
        else:
            event.ignore()

    # 函数：鼠标移动事件
    def mouseMoveEvent(self, event):
        if (self.status == BUTTON_PRESSED):
            self.leave_btn.emit()
            self.move_pos = event.globalPos()
            self.move(self.move_pos - self.drag_pos)
            self.setWindowOpacity(1)
            event.accept()

    # 处理鼠标离开事件
    def mouse_leave_event(self):
        self.hide()