#!/usr/bin/python3
# -*- coding: utf-8 -*-

__author__ = 'lixiang'

from PyQt5.QtGui import *
from PyQt5.QtCore import *
from mainui.systembutton import SystemButton
from utils.enums import VERSION
from mainui.button import *

import gettext
gettext.textdomain("kylin-update-manager")

_ = gettext.gettext


class TopWidget(QWidget):

    m_parent = None

    def __init__(self, appmsg,parent=None):
        super(TopWidget, self).__init__(parent)
        self.m_parent = parent
        self.app_msg=appmsg
        self.setFixedSize(450,80)
        self.setWindowFlags(Qt.FramelessWindowHint)
        self.init_ui()
        self.show()

    #
    # 函数：初始化ui
    #
    def init_ui(self):
        self.setAutoFillBackground(True)
        palette = QPalette()
        palette.setColor(QPalette.Background, QColor(255,255,255))
        self.setPalette(palette)

        self.btn_close = SystemButton(False,False,True,self)
        self.btn_close.setGeometry(416, 4, 30, 30)

        self.applogolabel = QLabel(self)
        self.applogolabel.resize(32, 32)
        self.applogolabel.move(15,15)
        #self.applogolabel.setGeometry(15, 15, 0, 0)
        pixmap = QPixmap(self.app_msg.ICON)
        if pixmap.isNull():
            pixmap = QPixmap("./res/soft_logo.png")
        self.applogolabel.setPixmap(pixmap)
        self.applogolabel.setAlignment(Qt.AlignVCenter | Qt.AlignHCenter)
        #self.applogolabel.setStyleSheet("QLabel{border:1px solid #6B8EEB;}")
        self.appnamelabel = QLabel(self)
        self.appnamelabel.setFixedWidth(300)
        #self.appnamelabel.resize(200,16)
        self.get_appname()
        self.appnamelabel.setStyleSheet("QLabel{color:#444444;font-size:16px;}")
        self.appnamelabel.move(59,17)
        #self.appnamelabel.setGeometry(57, 17, 0, 0)
        self.appversionlabel = QLabel(self)
        self.appversionlabel.setFixedWidth(300)
        #self.appversionlabel.resize(200,16)
        self.appversionlabel.setText(_("version:")+self.app_msg.CANDIDATEVERSION)
        self.appversionlabel.setStyleSheet("QLabel{color:#888888;font-size:12px;}")
        self.appversionlabel.move(59,45)
        #self.appversionlabel.setGeometry(57, 40, 0, 0)



    def get_appname(self):
        if (self.app_msg.NAME == "kylin-update-desktop-app"):
            self.appnamelabel.setText("基本应用")
        elif (self.app_msg.NAME == "kylin-update-desktop-security"):
            self.appnamelabel.setText("安全更新")
        elif (self.app_msg.NAME == "kylin-update-desktop-support"):
            self.appnamelabel.setText("系统基础组件")
        elif (self.app_msg.NAME == "kylin-update-desktop-ukui"):
            self.appnamelabel.setText("桌面环境组件")
        elif (self.app_msg.NAME == "kylin-update-desktop-kernel"):
            self.appnamelabel.setText("系统内核组件")
        elif (self.app_msg.NAME == "kylin-update-desktop-kernel-3a4000"):
            self.appnamelabel.setText("系统内核组件")
        elif (self.app_msg.NAME == "kylin-update-desktop-kydroid"):
            self.appnamelabel.setText("kydroid补丁包")
        else:
            self.appnamelabel.setText(self.app_msg.NAME)