#!/usr/bin/python3
# -*- coding: utf-8 -*-

import os
import sys
import signal
import dbus
import dbus.mainloop.glib
from gi.repository import GObject
from service.single import SingleInstance

if __name__ == '__main__':
    #signal.signal(signal.SIGCHLD,signal.SIG_IGN)
    myapp = SingleInstance("/tmp/kylin-update-manager-%d.pid" % os.getuid())
    if myapp.is_already_running():
       print("Another instance of this systemdbus is already running")
       sys.exit("Another instance of this systemdbus is already running")
    os.environ["TERM"] = "xterm"
    os.environ["PATH"] = "/usr/local/sbin:/usr/local/bin:/usr/sbin:/usr/bin:/sbin:/bin:/usr/X11R6/bin"
    os.environ["DEBIAN_FRONTEND"] = "noninteractive"
    if os.path.exists("/var/lib/apt/lists/lock"):
        os.remove("/var/lib/apt/lists/lock")
    from kylindbus.daemon import Daemon
    dbus.mainloop.glib.DBusGMainLoop(set_as_default=True)
    GObject.threads_init()
    mainloop = GObject.MainLoop()
    #gobject.threads_init()
    #mainloop = gobject.MainLoop()
    #signal.signal(signal.SIGCHLD,signal.SIG_IGN)
    signal.signal(signal.SIGINT, lambda : mainloop.quit())
    Daemon(dbus.SystemBus(), mainloop)
    mainloop.run()
