#!/usr/bin/python3
# -*- coding: utf-8 -*-
__author__ = "huangsheng"


import dbus
import dbus.service


class UtilDbus(dbus.service.Object):

    def __init__(self, parent, bus_name, object_path="/cn/kylinos/KylinUpdateManager/singleton"):
        dbus.service.Object.__init__(self, bus_name, object_path)
        self.parent = parent

    def stop(self):
        """ stop the dbus controller and remove from the bus """
        self.remove_from_connection()

    #
    # 函数：显示到前端
    #
    @dbus.service.method("cn.kylinos.KylinUpdateManager.singleton")
    def bring_to_front(self):
        self.parent.single_work()

    #
    # 函数：显示deb文件
    #
    @dbus.service.method("cn.kylinos.KylinUpdateManager.singleton", in_signature='s', out_signature='')
    def show_deb_file(self, path):
        self.parent.slot_show_deb_detail(str(path))

    #
    # 函数：显示进度界面
    #
    @dbus.service.method("cn.kylinos.KylinUpdateManager.singleton")
    def show_loading_div(self):
        self.parent.slot_show_loading_div()